#  Copyright (c) PARRRATE T&V 2021. All rights reserved.

from typing import Generic, TypeVar

__all__ = ('Attachable',)

from bu4.evaluation.constructs.evaluable import Evaluable

T = TypeVar('T')


class Attachable(Generic[T]):
    def attach(self, t: T) -> Evaluable:
        raise NotImplementedError
