#  Copyright (c) PARRRATE T&V 2021. All rights reserved.

from bu4.evaluation.constructs.evaluable import Evaluable
from bu4.evaluation.constructs.evalue import EValue

__all__ = ('EException',)


class EException(EValue):
    def __init__(self, name: bytes):
        self.name = name

    def call(self, argument: Evaluable) -> Evaluable:
        return self

    def __str__(self):
        return f'«{self.name.decode()}»'
