#  Copyright (c) PARRRATE T&V 2021. All rights reserved.

from bu4.evaluation.constructs.evaluable import Evaluable
from bu4.evaluation.constructs.evalue import EValue
from bu4.evaluation.targets.avtarget import AVTarget

__all__ = ('AVCall',)


class AVCall(AVTarget):
    def __init__(self, argument: Evaluable):
        self.argument = argument

    def given(self, value: EValue) -> Evaluable:
        return value.call(self.argument)

    def __str__(self):
        return f'({self.argument})'
