#  Copyright (c) PARRRATE T&V 2021. All rights reserved.

from bu4.encoding.codes import CODE_XCPT
from bu4.indexing.constructs.iexception import IException
from bu4.indexing.constructs.indexed import Indexed
from bu4.parsing.extensions.CodeExtension import CodeExtension
from bu4.transform.states.transformfinished import TransformFinished
from bu4.transform.states.transformstate import TransformState

__all__ = ('XIXcpt',)


class XIXcpt(CodeExtension[Indexed], code=CODE_XCPT):
    def apply(self) -> TransformState[Indexed]:
        return TransformFinished(IException(self.parser.parse_name()))
