#  Copyright (c) PARRRATE T&V 2021. All rights reserved.

from bu4.encoding.codes import CODE_CALL
from bu4.linkable.constructs.parsed import Parsed
from bu4.linkable.constructs.pcall import PCall
from bu4.parsing.extensions.CodeExtension import CodeExtension
from bu4.transform.states.transformstate import TransformState

__all__ = ('XLCall',)


class XLCall(CodeExtension[Parsed], code=CODE_CALL):
    def apply(self) -> TransformState[Parsed]:
        return self.readlambda(
            lambda argument: self.readlambdafinished(
                lambda lambda_: PCall(
                    argument,
                    lambda_
                )
            )
        )
