#  Copyright (c) PARRRATE T&V 2021. All rights reserved.

from bu4.encoding.codes import CODE_DLYD
from bu4.linkable.constructs.parsed import Parsed
from bu4.linkable.constructs.pdelayed import PDelayed
from bu4.parsing.extensions.CodeExtension import CodeExtension
from bu4.transform.states.transformstate import TransformState

__all__ = ('XLDlyd',)


class XLDlyd(CodeExtension[Parsed], code=CODE_DLYD):
    def apply(self) -> TransformState[Parsed]:
        return self.readlambdafinished(
            lambda value: PDelayed(value)
        )
