#  Copyright (c) PARRRATE T&V 2021. All rights reserved.

from bu4.encoding.codes import CODE_NULL
from bu4.linkable.constructs.parsed import Parsed
from bu4.linkable.constructs.pnull import PNull
from bu4.parsing.extensions.CodeExtension import CodeExtension
from bu4.transform.states.transformfinished import TransformFinished
from bu4.transform.states.transformstate import TransformState

__all__ = ('XLNull',)


class XLNull(CodeExtension[Parsed], code=CODE_NULL):
    def apply(self) -> TransformState[Parsed]:
        return TransformFinished(PNull())
