#  Copyright (c) PARRRATE T&V 2021. All rights reserved.

from bu4.encoding.codes import CODE_QOPN, CODE_QCLS
from bu4.linkable.constructs.parsed import Parsed
from bu4.parsing.extensions.CodeExtension import CodeExtension
from bu4.transform.states.transformstate import TransformState

__all__ = ('XLQopn',)


class XLQopn(CodeExtension[Parsed], code=CODE_QOPN):
    def apply(self) -> TransformState[Parsed]:
        return self.endswith(CODE_QCLS, 'quot expected')
