#  Copyright (c) PARRRATE T&V 2021. All rights reserved.

from bu4.encoding.codes import CODE_QUOT
from bu4.linkable.constructs.parsed import Parsed
from bu4.parsing.extensions.CodeExtension import CodeExtension
from bu4.transform.states.transformstate import TransformState

__all__ = ('XLQuot',)


class XLQuot(CodeExtension[Parsed], code=CODE_QUOT):
    def apply(self) -> TransformState[Parsed]:
        return self.endswith(CODE_QUOT, 'quot expected')
