#  Copyright (c) PARRRATE T&V 2021. All rights reserved.

from bu4.encoding.codes import CODE_XCPT
from bu4.linkable.constructs.parsed import Parsed
from bu4.linkable.constructs.pexception import PException
from bu4.parsing.extensions.CodeExtension import CodeExtension
from bu4.transform.states.transformfinished import TransformFinished
from bu4.transform.states.transformstate import TransformState

__all__ = ('XLXcpt',)


class XLXcpt(CodeExtension[Parsed], code=CODE_XCPT):
    def apply(self) -> TransformState[Parsed]:
        return TransformFinished(PException(self.parser.parse_name()))
