#  Copyright (c) PARRRATE T&V 2021. All rights reserved.

from bu4.evaluation.constructs.attachable import Attachable
from bu4.evaluation.constructs.evaluable import Evaluable
from bu4.indexing.constructs.indexed import Indexed
from bu4.linking.evaluation.elvtype import elvtype
from bu4.transform.states.transformstate import TransformState

__all__ = ('Linked',)


class Linked(Attachable[elvtype]):
    future: set[bytes]
    multifuture: set[bytes]

    def attach(self, env: elvtype) -> Evaluable:
        raise NotImplementedError

    def index(self, promise: list[bytes]) -> TransformState[Indexed]:
        raise NotImplementedError
