#  Copyright (c) PARRRATE T&V 2021. All rights reserved.

from typing import TypeVar, Callable

from bu4.transform.states.transformstate import TransformState

__all__ = ('TransformStart',)

T = TypeVar('T')


class TransformStart(TransformState[T]):
    def __init__(self, start: Callable[[], TransformState[T]]):
        self.start = start

    def next(self) -> TransformState[T]:
        return self.start()
