#  Copyright (c) PARRRATE T&V 2021. All rights reserved.

from bu4.evaluation.constructs.attachable import Attachable
from bu4.evaluation.constructs.evaluable import Evaluable
from bu4.indexing.evaluation.eivtype import eivtype
from bu4.transform.states.transformstate import TransformState
from bu4.transform.transform import transform

__all__ = ('Indexed',)


class Indexed(Attachable[eivtype]):
    def attach(self, ev: eivtype) -> Evaluable:
        raise NotImplementedError

    def bytes(self) -> TransformState[bytes]:
        raise NotImplementedError

    def __bytes__(self):
        return transform(self.bytes())
