#  Copyright (c) PARRRATE T&V 2021. All rights reserved.

from bu4.encoding.codes import CODE_DLYD
from bu4.indexing.constructs.idelayed import IDelayed
from bu4.indexing.constructs.indexed import Indexed
from bu4.parsing.extensions.CodeExtension import CodeExtension
from bu4.transform.states.transformstate import TransformState

__all__ = ('XIDlyd',)


class XIDlyd(CodeExtension[Indexed], code=CODE_DLYD):
    def apply(self) -> TransformState[Indexed]:
        return self.readlambdafinished(
            lambda value: IDelayed(value)
        )
