#  Copyright (c) PARRRATE T&V 2021. All rights reserved.

from bu4.encoding.codes import CODE_NAME
from bu4.indexing.constructs.iname import IName
from bu4.indexing.constructs.indexed import Indexed
from bu4.parsing.extensions.CodeExtension import CodeExtension
from bu4.transform.states.transformfinished import TransformFinished
from bu4.transform.states.transformstate import TransformState

__all__ = ('XIName',)


class XIName(CodeExtension[Indexed], code=CODE_NAME):
    def apply(self) -> TransformState[Indexed]:
        return TransformFinished(IName(self.parser.read()))
