#  Copyright (c) PARRRATE T&V 2021. All rights reserved.

from bu4.encoding.codes import CODE_SKIP
from bu4.linkable.constructs.parsed import Parsed
from bu4.parsing.extensions.CodeExtension import CodeExtension
from bu4.parsing.states.parsingread import ParsingRead
from bu4.transform.states.transformstate import TransformState

__all__ = ('XLSkip',)


class XLSkip(CodeExtension[Parsed], code=CODE_SKIP):
    def apply(self) -> TransformState[Parsed]:
        return ParsingRead(self.parser)
