#  Copyright (c) PARRRATE T&V 2021. All rights reserved.

from typing import TypeVar, Generic

from bu4.transform.states.transformstate import TransformState

__all__ = ('AbstractExtension',)

T = TypeVar('T')


class AbstractExtension(Generic[T]):
    code: int

    def apply(self) -> TransformState[T]:
        raise NotImplementedError
