#  Copyright (c) PARRRATE T&V 2021. All rights reserved.

from typing import TypeVar

from bu4.transform.states.transformstate import TransformState

__all__ = ('TransformFinished',)

T = TypeVar('T')


class TransformFinished(TransformState[T]):
    def __init__(self, transformed: T):
        self.transformed = transformed

    def next(self) -> TransformState[T]:
        return self
